//
// jail.c
// A kick and dirty chrooted login shell implementation
//
//
// Juan M. Casillas <assman@gsyc.inf.uc3m.es>
// 3 / April / 2001 09:22
//
//
// $Id: jail.c,v 1.5 2001/04/10 15:42:13 assman Exp $
//
// $Log: jail.c,v $
// Revision 1.5  2001/04/10 15:42:13  assman
// added documentation, change the Makefile to check de dependencies
// with mkenv.sh added TODO file, removed debug messages in the code
//
// Revision 1.4  2001/04/10 10:33:23  assman
// added CHANGELOG, INSTALL files, moved mkenv.sh for each platform,
// added new info to the documentation
//
// Revision 1.2  2001/04/03 10:28:36  assman
// removed binary file added by error
// added CVS tags
//
//
//
// Released under GNU Public License v.2.0
// See LICENSE file for details
//
// Compile command:
//
// cc -o jail jail.c
//
// or better, use the Makefile: 
//
// make 
//
//
// Notes: 
//
// file must be owned by root and have the SUID permissions
// (4755 runs fine) to allow proper operation
//
// Bugs:
//
// some curious happen when trying to run jail in an IRIX 6.5
// when it starts, it becomes killed by itself. Tracing it, I
// think is a problem with the execve() system call. Workarrounds
// are wellcome.
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <pwd.h>


//
// customize your shell here
// note you need other libraries than
// the ones installed by the script
//

#define SHELL "/bin/bash"

#define HOME_VAR "HOME="
#define VERSION "1.2 stable"

#define BANNER "\nJail version " VERSION "\n\n" \
	       "This program is released under the GNU License\n" \
	       "Juan M. Casillas <assman@gsyc.inf.uc3m.es>\n" \
	       "See http://www.gsyc.inf.uc3m.es/~assman/jail\n" \
	       "for more info\n\n"


//
// duplicate cad into the ptr pointer (ptr is an array of pointers)
//

void init_env(char **ptr, char *cad) {

    *ptr = (char *)malloc(strlen(cad)+1);
    memset(*ptr,0,strlen(cad)+1);
    strcpy(*ptr,cad);
}

int main(int argc, char *argv[], char *env[]) {
    int ret;
    char **lenv;
    char **larg;
    int n,j;
    struct passwd *pwdent;
    int uid, gid;
    char *home_dir;
    char *ptr;
    char *schroot_dir;
    char *shome_dir;
    char *schdir;
    char *a;
    //
    // show info
    //

    if (argc > 1 && !strcmp(argv[1],"--version")) {
      fprintf(stderr,BANNER 
	      "params:\n\n"
	      "\t--version: show this version\n\n"
	      "this program is mainly used for login users into the system\n"
	      "so interactive use is not useful, as you can see :)\n\n"
	      "Info ends, so bailing out.\n\n");
      exit(0);
    }
    if (argc > 1) {
	fprintf(stderr,BANNER
		"error: You can't pass arguments to jail\n"
		"bailing out.\n\n");
	exit(1);
    }

    uid = getuid();
    gid = getgid();

    //
    // test if Im root
    //

    if (setgid(0) || setuid(0) || getuid() != geteuid() || 
	getgid() != getegid()) {
	fprintf(stderr,"I can't do the chroot() because Im not root");
    }
	
    //
    // get user information
    //

    pwdent = getpwuid(uid);

    //if (!getuid() && !getgid()) {
    //	puts("Im root");
    //    }
    

    if (env != NULL) {

	//
	// count elements and generate space for the array
	// then, save all the environment variables but don't
        // nothing in HOME and SHELL
        //

	n=0;
	while (env[n]) n++;  
	lenv = malloc(sizeof(char *)*n);

	n=j=0;
	while (env[n]) {
	    if ((strstr(env[n],"HOME")==NULL) && 
		(strstr(env[n],"SHELL")==NULL)) {
		init_env(&lenv[j],env[n]);  // copy argument
		//printf("%s\n",lenv[j]);
		j++;
	    }
	    n++;
	}	
    }

    //
    // process the HOME_VAR to do the path_splitting
    // find $ into the string, then build two strings
    // the chroot and the home directory
    //

    ptr = strchr(pwdent->pw_dir,'$');
    if (ptr) {
	schroot_dir = (char *)malloc(ptr-pwdent->pw_dir+1);
	bzero(schroot_dir,ptr-pwdent->pw_dir+1);

	//
	// copy first into chroot_dir
	//

	a = pwdent->pw_dir;
	n =0 ;
	while( *a != '$') {
	    schroot_dir[n] = *a;
	    n++;
	    a++;
	}
	a++; // skip '$'

	//
	// copy the trailing string to the home
	// directory. Note we don't need to 
	// add one, because we include the $ sign
	//

	a = ptr+1;
	shome_dir = (char *)malloc(strlen(pwdent->pw_dir)-strlen(schroot_dir));
	bzero(shome_dir,strlen(pwdent->pw_dir)-strlen(schroot_dir));
	n=0;
	while (*a != '\0') {
	    shome_dir[n]=*a;
	    a++;
	    n++;
	}

	//
	// check for null strings
	// and bail out if error
	//

	if ((strlen(schroot_dir)==0) || (strlen(shome_dir)==0)) {
	    fprintf(stderr,"Can't do chroot: invalid user home directory.\n");
	}

	schdir = (char *)malloc(strlen(schroot_dir)+strlen(shome_dir)+2);
	bzero(schdir,strlen(schroot_dir)+strlen(shome_dir)+2);

	strcpy(schdir,schroot_dir);
	strcat(schdir,"/");
	strcat(schdir,shome_dir);

    }
    else {
	shome_dir = pwdent->pw_dir;
	schroot_dir = pwdent->pw_dir;
	schdir = pwdent->pw_dir;
    }


    //
    // now, override HOME and SHELL with our custom
    // values, so the jail runs fine
    //
    
    //home_dir = (char *)malloc(strlen(HOME_VAR)+strlen(pwdent->pw_dir)+1);
    // memset(home_dir,0,strlen(HOME_VAR)+strlen(pwdent->pw_dir)+1);
    //strcpy(home_dir,HOME_VAR);
    //strcat(home_dir,pwdent->pw_dir);
    
    
    home_dir = (char *)malloc(strlen(HOME_VAR)+strlen(shome_dir)+1);
    memset(home_dir,0,strlen(HOME_VAR)+strlen(shome_dir)+1);
    strcpy(home_dir,HOME_VAR);
    strcat(home_dir,shome_dir);

    /*
      printf("schroot_dir(%s)\n",schroot_dir);
      printf("shome_dir(%s)\n",shome_dir);
      printf("home_dir(%s)\n",home_dir);
    */


    //
    // j is used before, when we count the env arguments
    // maybe this value need to has is own variable

    init_env(&lenv[j],home_dir); j++;
    init_env(&lenv[j],"SHELL=" SHELL); j++;	
    lenv[j]=NULL;

    larg = malloc(sizeof(char *)*4); // whe only need four parameters

    init_env(&larg[0],argv[0]);
    init_env(&larg[1],"-");
    larg[2]=NULL;

    //
    // change dir to the home directory
    //

    // n=0;
    //while (lenv[n]) {
    //	printf("ENV: %s\n",lenv[n]);
    //	n++;
    //    }
   

    ret = chdir(schdir);	
    if (ret) {
	perror("chdir() ");
	return(ret);
    }
	
    ret = chroot(schroot_dir);
    if (ret) { 
	perror("chroot() ");
	return(ret);
    }

    //
    // become the user
    //

    setgid(gid);
    setuid(uid);

    //
    // launch the shell overrinding current process space
    //

    ret = execve(SHELL,larg,lenv);
    if (ret) { 
	perror("execve() ");
	return(errno);
    }

    return(0); // not reached and if so, we are in trouble :(
}

    
