#!/bin/bash

if [ $# -lt 1 ]; then
	echo "Usage: $0 HOMEDIR"
	exit 1;
fi

HDIR=$1

echo "Making $HDIR chrooted environment"

mkdir -p $HDIR/bin $HDIR/dev $HDIR/etc $HDIR/lib $HDIR/tmp $HDIR/var/tmp \
         $HDIR/usr/share/terminfo $HDIR/usr/share/locale $HDIR/usr/lib
cp /lib/ld-linux.so.2 /lib/ld.so /lib/libc.so.6 /lib/libdl.so.2 \
   /lib/libnsl.so.1 /lib/libnss_compat.so.2 \
   /lib/libtermcap.so.2 $HDIR/lib

cp -r /etc/group /etc/localtime /etc/nsswitch.conf \
      /etc/passwd /etc/shadow $HDIR/etc

cp -r /usr/lib/libncurses.so.4 $HDIR/usr/lib

cp -r /usr/share/terminfo /usr/share/locale  $HDIR/usr/share 

cp /bin/bash /bin/cat /bin/grep /usr/bin/id /bin/ls /bin/mkdir /bin/mv \
   /bin/cp /bin/ln /bin/mv /bin/pwd /bin/rm /bin/rmdir /bin/sh /usr/bin/tail \
   /bin/more /bin/touch /bin/vi /usr/bin/head $HDIR/bin

mknod $HDIR/dev/zero c 1 5
mknod $HDIR/dev/null c 1 3

chown -R root:root $HDIR/bin $HDIR/dev $HDIR/etc $HDIR/lib $HDIR/tmp $HDIR/var
